Subject: Re: bug#36510: confusing mcron logging

From: Maxim Cournoyer <[email-masked]>
Date: Sun, 20 Nov 2022 20:22:25 -0500

Hello Dale,

Dale Mellor <[email-masked]> writes:

> Hi, sorry for the delay but I've had a bit of time over Christmas
>    to look things over. I've given this a lot of consideration.

Apologies for my lack of reply thus far, it seems your mail had fallen
in cracks.

>
> I am happy to drop compatibility with guile-2.2 and older; I think we
> can make a minor version bump for this break with legacy.
>
>
>
> Does this belong in mcron?  The mcron source code is currently
>    3,000 lines, to which you are bringing over 500 new ones to
>    make a facility which is geared towards debugging in the GUIX
>    system (I am all-in on GUIX myself, but mcron is a generic GNU
>    program with use-cases outside of this system).  I wonder if
>    this is the best place: perhaps it is shepherd, which is
>    responsible for the /var/log/mcron.log file, to be responsible
>    for the amended logging messages?  And then again, isn't this
>    exactly what syslogd does anyway?  Most likely timings will be
>    more accurate if they are generated in mcron.

Since Shepherd 0.9+, it now appends logging information to every output
it handles, so this feature has indeed become less important, but still
useful: I've recently bumped our package of mcron in Guix and I'm using
its annotation facility to prepend the process ID to its output.  I
think the grunt of new lines added must be as documentation and test
code, so that's not so bad as it seems I think.

>    In your use-case, of debugging the system, I would think that
>    more specialized messages placed directly in the cron jobs
>    themselves would be a better aid to your work, as you can
>    target them to the problem at hand.  And you could send those
>    to syslogd if you wanted.

Here's a sample output from the Guix build farm:

--8<---------------cut here---------------start------------->8---
2022-11-21 01:56:15 84005 /gnu/store/ypyz886hd7qaw0g8ba5a595dc0qgnj3q-update-guix.gnu.org: running...
2022-11-21 01:59:24 84005 /gnu/store/ypyz886hd7qaw0g8ba5a595dc0qgnj3q-update-guix.gnu.org: Updating channel 'guix' from Git repository at 'https://git.savannah.gnu.org/git/guix.git'...
2022-11-21 01:59:24 84005 /gnu/store/ypyz886hd7qaw0g8ba5a595dc0qgnj3q-update-guix.gnu.org: Computing Guix derivation for 'x86_64-linux'...  
2022-11-21 01:59:24 84005 /gnu/store/ypyz886hd7qaw0g8ba5a595dc0qgnj3q-update-guix.gnu.org: [2022-11-21T01:56:18+0100] building web site from 'https://git.savannah.gnu.org/git/guix/guix-artwork.git'...
2022-11-21 01:59:24 84005 /gnu/store/ypyz886hd7qaw0g8ba5a595dc0qgnj3q-update-guix.gnu.org: completed in 189.325s
2022-11-21 02:00:00 91665 /gnu/store/xsc4x68avp8nmrf3hgvhd26yl3k90jqz-check-disk-space: running...
2022-11-21 02:00:00 91665 /gnu/store/xsc4x68avp8nmrf3hgvhd26yl3k90jqz-check-disk-space: completed in 0.046s
--8<---------------cut here---------------end--------------->8---

The timestamp is now generated by Shepherd, and mcron adds the PID of
the job, such as 84005 above.  To have some indication of how long the
job ran available at a quick glance is very useful for admin purposes.

>
>
> The output is a little unpredictable.  The script (which is
>    admittedly somewhat pathological)
>
>      (job '(next-second '(0 30)) '(begin (display "test: ")
>                                          (system "date")))
>
>    produces
>
>      2022-01-04T11:24:00 (...): running...
>      2022-01-04T11:24:00 (...): Tue 4 Jan 11:24:00 GMT 2022
>      2022-01-04T11:24:00 (...): test: completed in 0.022s
>      2022-01-04T11:24:30 (...): running...
>      2022-01-04T11:24:30 (...): Tue 4 Jan 11:24:30 GMT 2022
>      2022-01-04T11:25:00 (...): running...
>      2022-01-04T11:25:00 (...): Tue 4 Jan 11:25:00 GMT 2022
>      ...

I've noticed that too, that some jobs somehow escape producing the
"completed in x..." message.  I'll try looking into that, it's probably
a subtle bug.

> But all things considered your changes are generally useful to
>    have, including outside of the GUIX system, and I would very
>    much like to have them there.  But to be sure not to break any
>    existing applications, I would like the changes to be opt-in
>    via a command-line switch -l; the --log-format option can
>    remain to customize this (please also make -L a short option
>    alternative; also -D as short for --date-format).
>
>    I am willing and able to do this work myself in a reasonable
>    time-frame if you would like me to.

Thank you for taking on yourself the above work, Dale!  I was happily
surprise to see this change had landed with your improvement on top.

I think this Guix issue can now be closed :-).

-- 
Thanks,
Maxim